#include <stdio.h>
#include <set>
#include <algorithm>
#include <queue>

#define NMAX 1024
#define INF 666666
#define UP 0
#define SAME 1
#define DOWN 2

using namespace std;

int N, M, R, DEL;
int D[NMAX];
set<int> F[NMAX];
set<int>::iterator it;
int V[3][NMAX];

struct sort_order {
  bool operator()(const int& a, const int& b) const {
    return D[a] > D[b];
  }
} so;


void bf(priority_queue<int, vector<int>, sort_order> pq) {
  while (!pq.empty()) {
    int c = pq.top();
    pq.pop();
    for (it = F[c].begin(); it != F[c].end(); it++) {
      if (D[*it] == INF) {
        D[*it] = D[c] + 1;
        pq.push(*it);
      }
    }
  }
}

void bf() {
  for (int i = 1; i <= N; i++) {
    D[i] = INF;
  }
  priority_queue<int, vector<int>, sort_order> pq;
  D[R] = 0;
  pq.push(R);
  bf(pq);
}

void computeV(int vf) {
  int v, level;
  V[UP][vf] = 0;
  V[SAME][vf] = 0;
  V[DOWN][vf] = 0;
  for (it = F[vf].begin(); it != F[vf].end(); it++) {
    v = *it;
    level = (D[vf] == D[v] + 1) * UP
          + (D[vf] == D[v]) * SAME
          + (D[vf] == D[v] - 1) * DOWN;
    V[level][vf]++;
  }
}

void computeV() {
  int i;
  for (i = 1; i <= N; i++) {
    computeV(i);
  }
}


int fall(int vf) {
  int q[NMAX];
  int l, r, c;
  set<int> stable;

  l = r = 0;
  q[l] = vf;
  while (l <= r) {
    c = q[l];
    for (it = F[c].begin(); it != F[c].end(); it++) {
      if (D[c] == D[*it] - 1) {
        if (--V[UP][*it] == 0) {
          q[++r] = *it;
        }
      }
    }
    D[c] = INF;
    
    l++;
  }

  for (int i = 0; i < l; i++) {
    c = q[i];
    for (it = F[c].begin(); it != F[c].end(); it++) {
      if (D[*it] != INF) {
        stable.insert(*it);
      }
    }
  }

  priority_queue<int, vector<int>, sort_order> pq;
  int bfq[N], p = 0;
  for (it = stable.begin(); it != stable.end(); it++) {
    pq.push(*it);
    bfq[p++] = *it;
  }
  bf(pq);
  
  for (int i = 0; i < l; i++) {
    computeV(q[i]);
  }
  for (int i = 0; i < p; i++) {
    computeV(bfq[i]);
  }

  return l;
}

int eval(int vf) {
  if (V[UP][vf] > 0) {
    return 0;
  }

  return fall(vf);
}

int main() {
  int a, b;
  freopen("cadere.in", "r", stdin);
  scanf("%d %d %d %d", &N, &M, &R, &DEL);

  while (M--) {
    scanf("%d %d", &a, &b);
    F[a].insert(b);
    F[b].insert(a);
  }

  freopen("cadere.out", "w", stdout);
  bf();
  computeV();
  while (DEL--) {
    int f;
    
    scanf("%d %d", &a, &b);
    F[a].erase(b);
    F[b].erase(a);

    if (D[a] == D[b]) {
      V[SAME][a]--;
      V[SAME][b]--;
      f = 0;
    } else {
      if (D[a] < D[b]) {
        V[UP][b]--;
        V[DOWN][a]--;
        f = eval(b);
      } else {
        V[UP][a]--;
        V[DOWN][b]--;
        f = eval(a);
      }
    }

    printf("%d\n", f);
  }

  return 0;
}

